// ProgramFile.h: interface for the CProgramFile class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PROGRAMFILE_H__65644607_CD12_4D43_BEB1_582AE86B02E7__INCLUDED_)
#define AFX_PROGRAMFILE_H__65644607_CD12_4D43_BEB1_582AE86B02E7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "TransferrableFile.h"

class CSerialPort;

const unsigned short MIPSELMAGIC=0x0162;

class CProgramFile : public CTransferrableFile  
{
public:
	enum programType
	{
		unknown, 
		psxExe,
		aOutExe,
		fileNotFound
	};
	CProgramFile();
	virtual ~CProgramFile();
	bool Send(CSerialPort& port);
	bool SetupRegisters();
	static programType CProgramFile::FindType(TCHAR* filename);
	virtual bool OpenForReading(TCHAR* filename)=0;



protected:
	CSerialPort* m_pPort;
	unsigned int m_GPValue;
	unsigned int m_PCValue;
	unsigned int m_SPValue;

};

#endif // !defined(AFX_PROGRAMFILE_H__65644607_CD12_4D43_BEB1_582AE86B02E7__INCLUDED_)
